﻿package 
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FullScreenEvent;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.utils.setInterval;

	public class Liner extends Sprite
	{
		public var balls:Array

		public function Liner()
		
		{
			balls = new Array();
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		
		private function addedHandler(e:Event):void
		{
			stage.addEventListener(FullScreenEvent.FULL_SCREEN,fullhandler);
			setInterval(buildScreen,10);
			stage.addEventListener(MouseEvent.MOUSE_MOVE,clickHandler);
		}
		private function fullhandler(e:FullScreenEvent):void
		{
			balls = new Array();
		}
		private function clickHandler(e:MouseEvent):void
		{
			var pt:Point = new Point(e.stageX,e.stageY);
			var obj:Object = {"posx":this.globalToLocal(pt).x,"posy":this.globalToLocal(pt).y,"angle":0,"rayon":(Math.random()*100 + 30),"centerY":this.globalToLocal(pt).y};
			obj.x = -300;
			obj.y = -300;

			balls.push(obj);
			balls.sortOn(["posx"],[Array.NUMERIC]);

			
		}
		
		private function buildScreen():void
		{
			this.graphics.clear();
			for(var i:Number = 0;i<balls.length;i++){
				
				graphics.beginFill(0x9600ff,0.5);
				graphics.drawCircle(balls[i].posx,balls[i].posy*2,Math.random()*2);
				graphics.endFill();
				graphics.lineStyle(Math.random()*30,0x9600ff,0.1);				


				if(i>3){
					
					
					graphics.moveTo(balls[i-1].posx,balls[i-1].posy);
					graphics.lineTo(balls[i].posx,balls[i].posy);
					graphics.moveTo(balls[i-2].posx,balls[i-2].posy);
					graphics.lineTo(balls[i].posx,balls[i].posy);
		

				}
				graphics.lineStyle();
				//set the new position
				
				balls[i].posy = balls[i].centerY + Math.sin(balls[i].angle*Math.PI/300+300)*balls[i].rayon;
				balls[i].posx = balls[i].centerY + Math.cos(balls[i].angle*Math.PI/300)*balls[i].rayon;

				balls[i].angle++;
			}
		}
	}
}